<?php
namespace Drupal\instagram_block\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\JsonResponse;

/**
 * Provides route responses for the Example module.
 */
class CustomInstagramController extends ControllerBase {

  public function call_ajax($block_id){
    $block_manager = \Drupal::service('plugin.manager.block');

    $ids = \Drupal::entityQuery('block')
      ->condition('plugin', 'instagram_block_block')
      ->execute();
    foreach ($ids as $id) {
      if ($block_id === $id) {
        // Migrating configuration to the block.
        $block_config = \Drupal::configFactory()->getEditable('block.block.' . $id);
        $settings = $block_config->get('settings');
      }
    }

    // Getting the block
    $plugin_block = $block_manager->createInstance('instagram_block_block', $settings);

    $access_result = $plugin_block->access(\Drupal::currentUser());
    // Return empty render array if user doesn't have access.
    if ((is_bool($access_result) && !$access_result) || (is_object($access_result) && $access_result->isForbidden())) {
      // You might need to add some cache tags/contexts.
      return [];
    }
    $label = $plugin_block->label();
    $render = $plugin_block->build();

    $result['title'] = $label;
    $result['html'] =  \Drupal::service('renderer')->render($render);
    return new JsonResponse($result);
  }
}
